<?php
require_once("Session.php");

class Access {

	# Singleton
	static $instance = null;

	static function getInstance() {
		if ( self::$instance == null ) {
			self::$instance = new Access();
		}
		return self::$instance;
	}
	
	# members
	var $berechtigung;
	
    function __construct(){
    	
    	// $berechtigung mappt die Funktionen auf Profile
		// dabei ist "default" das generische Profil aller 
		// registrierten Benutzer 

        $this->berechtigung = array(
			"ausleihe.leiheAus"	=> "default");
    }
	
	function berechtigung( $function ) {
		switch ( $function ) {
			case "ausleihe.leiheAus": $this->pruefe($function); break;
			default:  throw new Exception("keine Berechtugung für $function", ACCESS);
		}
	}
	
	function pruefe( $function ) {
		// bestimme Nutzer
		$session = Session::getInstance();
		$nutzer = $session->get("nutzer", "");
		if ( $nutzer == "" ) {
			// es muss ein explititer Nutzer besimmbar sein!
			throw new Exception("kein Nutzer bestimmbar", ACCESS);
		}

		// werte Berechtigung aus
		switch ( $this->berechtigung ) {
			case "default": return;
			default: throw new Exception("keine Berechtugung für $function", ACCESS);
		}
	}
}

?>