<?php
interface InputExtractor {
	/** the possible values for extract control */
	const EC_BEG = 1; // begin of subtree (current node descends) - in
	const EC_CTN = 2; // continue with next sibling element - in / out: data of found element 
	const EC_END = 3; // subtree completion (current node ascends); no data - out

	public function openInput($input);
	public function toTop();	// navigation: current node := top level node
	public function toParent();	// navigation: current node := parent node
	public function extractElement($extr_ctl, &$elem, &$value, &$attrs);
	// $extr_ctl: extract control, see above
	// $elem: label (not on EC_END)
	// $value, if present
	// $attrs, key value pairs, e.g. "id => 1", "mod => 3"
	// returns extract control
}
